class ARRAYED_SEQUENCE[E]

inherit SEQUENCE[E]

creation from_array, from_iterator

feature {NONE} -- Creation

	from_array (a: ARRAY[E]) is
	do
		storage := a
	end

	from_iterator (i: ITERATOR[E]) is
	do
		create storage.make (1, 0)
		from
			i.start
		until
			i.is_off
		loop
			storage.add_last (i.item)
			i.next
		end
	end

feature -- Operations

	count: INTEGER is
	do
		Result := storage.count
	end

	item, infix "@" (i: INTEGER): E is
 	do
		Result := storage.item (i)
	end

feature -- Internal

	storage: ARRAY[E]

invariant

	storage /= Void

end -- class ARRAYED_SEQUENCE[E]
