class ITERATOR_ON_SEQUENCE[E]

inherit
	BETTER_ITERATOR[E];

creation
	make

feature {NONE}

	sequence: SEQUENCE[E]
			-- The one to be traversed.

	item_index: INTEGER
			--  Memorize the current position.

feature

	make(c: like sequence) is
	require
		c /= Void
	do
		sequence := c
		start
	ensure
		sequence = c
	end

	start is
	do
		item_index := sequence.lower
	end

	is_off: BOOLEAN is
	do
		Result := not sequence.valid_index(item_index)
	end

	item: E is
	do
		Result := sequence.item(item_index)
	end

	next is
	do
		item_index := item_index + 1
	end

invariant

	sequence /= Void

end -- class ITERATOR_ON_SEQUENCE
