class ITERATOR_ON_SUBSEQUENCE[E, SUB] -- SUB->E
	-- Itera sobre los elementos de un SEQUENCE[E] que son de tipo SUB 

inherit
	BETTER_ITERATOR[SUB];

creation
	make

feature {NONE}

	sequence: SEQUENCE[E]
			-- The one to be traversed.

	item_index: INTEGER
			--  Memorize the current position.

feature

	make(c: like sequence) is
	require
		c /= Void
	do
		sequence := c
		start
	ensure
		sequence = c
	end

	start is
	do
		item_index := sequence.lower
	end

	is_off: BOOLEAN is
	do
		Result := not sequence.valid_index(item_index)
	end

	item: SUB is
	do
		Result ?= sequence.item(item_index)
	end

	next is
	local
		t: like item
	do
		from
			item_index := item_index + 1
		until
			is_off or t /= Void
		loop
			t ?= sequence.item (item_index)
			item_index := item_index + 1
		end
	end

invariant

	sequence /= Void

end -- class ITERATOR_ON_SUBSEQUENCE
