deferred class TRAVERSER_ON_SEQUENCE[G->SEQUENCE[ANY]]

feature {NONE} -- Data

	index: INTEGER

	sequence: G

feature -- operations

	set_index (new: like index) is
	do
		index := new
	end

	update is
	deferred
	end

	move_next is
		-- go to the next record
	do
		set_index (index + 1)
		update
	end

	move_previous is
		-- go to the previous record
	do
		set_index (index - 1)
		update
	end

	move_first is
		-- go to the first record
	do
		set_index (1)
		update
	end

	move_last is
		-- go to the last record
	do
		set_index (sequence.count)
		update
	end

invariant

	sequence /= Void implies (sequence.count > 0 implies sequence.valid_index (index))

end -- class TRAVERSER_ON_SEQUENCE
